#!/usr/bin/env python
#########################################################
#              RETicker v. 0.5.0
# a programm to display xml-formatted rss/rdf-feeds in
# a one line display
#########################################################
# please read Help.txt for contact information

#########################################################
# This file contains the classes for all widgets to     #
# build the ticker-window                               #
#########################################################
from __future__ import generators
# import findrox; findrox.version(1,9,12)
# it uses a patched version of ROX-Lib2 in rox/
import rox
from rox import applet, g, tasks

import sys
import os
import gobject

import tool
import overview	
#from Options import *
import Options
import ticker_menu
from news import news_, show_list

global minsize ### a Identifier for miniatur icons
#minsize = g.icon_size_register("minimal-size-9-9", 9, 9)
#minsize = g.icon_size_register("minimal-size-13-13", 13, 13)
#minsize = g.icon_size_register("minimal-size-11-11", 11, 11)
minsize = g.icon_size_register("minimal-size-12-12", 12, 12)

### old imports: mightbe deleted sometimes ;)
#from rox.options import Option
#from xml.dom import minidom
#import xml.sax
#import urllib
#import gc
#import re
#import time

### This is the Main-Container. To get overall access to its contens,
### it is defined a a global variable called main - its not really nice ;(
class MainContainer:
	def __init__(self, V, Version, user_conf, verbose):
		### here are the Options (including info about the sources) stored
		self.__Options = Options.Options_(V, Version, user_conf, verbose)
        	### The box holds the Ticker-Label and the Ticker-Icon
		self.__box = Label_box(self.__Options); self.add(self.__box)
		### show_list is a class wich presents a view of the news
		self.__show_list = show_list(self.__Options, self.__box)
		### this is the active-ticker-window
		self.__act_tick = overview.ov_aktfeed(self.__Options, self.__show_list)		
		### this is the overview-window an contain
		self.__overview = overview.overview(self.__Options, self.__show_list)
		### and the hole thing needs a menu
		self.__menu = ticker_menu.menu(self.__Options, self)
		### set cross-object reaction to signals
		self.__box.set_callback_events(self, self.__show_list)
		self.__show_list.connect("cached_news_read_slave", self.__act_tick.create_window)
		self.__show_list.connect("next_feed_in_showlist", self.__act_tick.akt_feed)
		self.__show_list.connect("refresh_feed_done_slave", self.__act_tick.refresh_if_actual)
		self.__show_list.connect("refresh_feed_done_slave", self.__overview.reinit)
		self.__box.image.connect("tickbild_entered", self.show_overview_as_tip)
		self.__box.image.connect("tickbild_leaved", self.__act_tick.hide_later)
		self.__box.image.connect("open_menu", self.open_menu)
		self.__box.image.connect("open_menu", self.__act_tick.show_now_as_menu)
		#self.__act_tick.nav.connect("next_feed", self.exit_prog)
		#self.__act_tick.nav.connect("prev_feed", self.exit_prog)
		#self.__act_tick.nav.connect("open_feed_page", self.exit_prog)
		self.__act_tick.connect("size_changed_tt_a", self.__Options.act_tick_size_changed)
		self.__act_tick.nav.connect("refresh_all", self.__show_list.start_refresh)
		self.__act_tick.nav.connect("open_options", self.__Options.show_options)
		self.__act_tick.nav.connect("open_overview_window", self.__overview.recreate_window)
		self.__act_tick.nav.connect("help", self.open_help)
		self.__act_tick.nav.connect("info", self.info)
		self.__act_tick.nav.connect("quit", self.exit_prog)
		self.__act_tick.stat.connect("switch_active", self.__Options.sources_switch_feed_active)
		self.__act_tick.stat.connect("refresh_feed", self.__show_list.refresh_feed)
		self.__overview.connect("switch_active_slave", self.__Options.sources_switch_feed_active)
		self.__overview.connect("refresh_feed_slave", self.__show_list.refresh_feed)
		self.__overview.connect("size_changed_ov", self.__Options.overview_size_changed)
		self.__Options.connect("refresh_scrollbars", self.__act_tick.set_scrollbars)
		self.__Options.connect("refresh_update_time", self.__show_list.refresh_update)
		self.__Options.connect("refresh_refresh_time", self.__show_list.refresh_refresh)
		self.__Options.connect("refresh_win_size", self.set_size)
		self.__Options.connect("refresh_label_color", self.__box.label.set_color)
		self.__Options.connect("refresh_transparency", self.refresh_transparency)
		self.__Options.connect("refresh_background", self.update_back_color)
		self.__menu.connect("m_quit", self.exit_prog)
		self.__menu.connect("m_help", self.open_help)
		self.__menu.connect("m_info", self.info)
		self.__menu.connect("m_show_window", self.__overview.recreate_window)
		self.__menu.connect("m_show_options", self.__Options.show_options)
		self.__menu.connect("m_refresh_ticker", self.__show_list.start_refresh)
		#self.__menu.connect("m_update_ticker", self.exit_prog)
		
		### pixbufs for transparency -- and initialisation
		self.__pixbuf_back = None; self.__pixbuf = None
		self.__pixbuf_label = None; self.__pixbuf_image = None
		self.activate_transparency()
		self.connect("destroy", self.__del__)
		self.connect('configure-event',self.win_configure)
		
		### some formatting an done !
		if self.applet:
			self.set_size_request(self.__Options.hor_size.int_value, self.__Options.ver_size.int_value)
		else: self.set_size_request(10,10)
		self.set_size()
		self.show()
	def info(self, dummy = None):
        	InfoWin.infowin(" " + self.__Options.Version + " ")
	def open_help(self, dummy = None):
		Help = g.Window()
		Help.set_title(" " + self.__Options.Version + " ")
		HelpTab = Options.Help_Container()
		Help.add(HelpTab)
		Help.show()
	def set_size(self, dummy = None):
		#self.set_size_request(-1, -1)
		if self.applet or self.__Options.hor_size.int_value <= 0 or self.__Options.ver_size.int_value <= 0:
			#print str(self.__Options.hor_size.int_value) + " " + str(self.__Options.ver_size.int_value)
			self.set_size_request(self.__Options.hor_size.int_value, self.__Options.ver_size.int_value)
		else:
			self.set_size_request(10,10)
			self.resize(self.__Options.hor_size.int_value, self.__Options.ver_size.int_value)
	def open_menu(self, dummy, event):
		if self.__Options.tt_a.int_value == 0 \
			or self.__Options.tt_a_as_menu.int_value == 0:
			self.__menu.popup(self.__menu, event, self.position_menu)
	def __del__(self, dummy):
		# change this
		self.__show_list.export_xml()
		#print "last_size " + str(self.__Options.hor_size.int_value) + "x" + str(self.__Options.ver_size.int_value)
		rox.app_options.save(); print "Options saved"
		#print "last_size " + str(self.__Options.hor_size.int_value) + "x" + str(self.__Options.ver_size.int_value)
		print "Good Bye"
		if self.__Options.OptionsBox: self.__Options.OptionsBox.destroy()
		self.destroy()
		g.main_quit()
	def exit_prog(self, dummy):
		self.destroy()
	def update_back_color(self, dummy):
		self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color(self.__Options.back_color.value))
		self.__box.label.modify_bg(g.STATE_NORMAL,\
			self.__box.label.get_colormap().alloc_color(self.__Options.back_color.value))
		self.__box.label.modify_bg(g.STATE_PRELIGHT,\
			self.__box.label.get_colormap().alloc_color(tool.back_color_prelight(self.__Options)))
		self.__box.image.modify_bg(g.STATE_NORMAL,\
			self.__box.image.get_colormap().alloc_color(self.__Options.back_color.value))
		self.__box.image.modify_bg(g.STATE_PRELIGHT,\
			self.__box.image.get_colormap().alloc_color(tool.back_color_prelight(self.__Options)))
	def refresh_transparency(self, dummy):
		self.activate_transparency()
		### if transparency had changed, shake the window a little bit ;)
		### mightbe its better to tell this the win-manager directly
		x, y = self.window.get_position(); self.move(x+1, y); self.move(x-1, y)
		#self.queue_draw()
	def activate_transparency(self):
		if (self.__Options.transparent.int_value) == 0 or not(os.path.isfile(self.__Options.back_datei.value)):
			self.set_app_paintable(False)
			self.__box.label.set_app_paintable(False)
			self.__box.image.set_app_paintable(False)
			self.update_back_color(None)
			return
		### read background-image from File (set in Options)
		self.__pixbuf_back = g.gdk.pixbuf_new_from_file(self.__Options.back_datei.value)
		self.set_app_paintable(True)
		self.__box.label.set_app_paintable(True)
		self.__box.image.set_app_paintable(True)
	def win_configure(self, dummy, event):
		if self.applet:
			w, h = self.size_request()
		else: w, h = self.get_size()
		if w <> self.__Options.hor_size.int_value or h <> self.__Options.ver_size.int_value:
			self.__Options.mainwin_size_changed(w, h)
		if (self.__Options.transparent.int_value): self.refresh_background(w, h)
	def refresh_background(self, w, h):
		w_b = self.__pixbuf_back.get_width()
		h_b = self.__pixbuf_back.get_height()
		x, y = self.window.get_position()
		w, h = self.get_size()
		if x < 0 or y < 0: return
		if x + w > w_b or y + h > h_b: return
		x_l, y_l = self.__box.label.window.get_position()
		w_l, h_l = self.__box.label.window.get_size()
		x_i, y_i = self.__box.image.window.get_position()
		w_i, h_i = self.__box.image.window.get_size()
		if self.__pixbuf: del self.__pixbuf
		self.__pixbuf = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w, h)
		if self.__pixbuf_label: del self.__pixbuf_label
		self.__pixbuf_label = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w_b - x - x_l, h_l)
		if self.__pixbuf_image: del self.__pixbuf_image
		self.__pixbuf_image = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w_i, h_i)
		self.__pixbuf_back.copy_area(x, y, w, h, self.__pixbuf, 0, 0)
		self.__pixbuf_back.copy_area(x+x_l, y+y_l, w_b - x - x_l, h_l, self.__pixbuf_label, 0, 0)
		self.__pixbuf_back.copy_area(x+x_i, y+y_i, w_i, h_i, self.__pixbuf_image, 0, 0)
		self.__pixmap, mask = self.__pixbuf.render_pixmap_and_mask()
		self.__pixmap_label, mask = self.__pixbuf_label.render_pixmap_and_mask()
		self.__pixmap_image, mask = self.__pixbuf_image.render_pixmap_and_mask()
		self.window.set_back_pixmap(self.__pixmap, False)
		self.__box.label.window.set_back_pixmap(self.__pixmap_label, False)
		self.__box.image.window.set_back_pixmap(self.__pixmap_image, False)
		self.resize(w,h)
		self.__box.label.hide()
		self.__box.label.show()
		self.__box.image.hide()
		self.__box.image.show()
	def show_overview_as_tip(self, dummy):
		x, y = self.window.get_position()
		w, h = self.size_request()
		self.__act_tick.show_now_as_tip(x, y, w, h)

### Program-Window
class TickerWindow(rox.Window, MainContainer):
        def __init__(self, V, Version, user_conf, verbose):
		rox.Window.__init__(self)
		self.applet = False
		self.__Options = None
		MainContainer.__init__(self, V, Version, user_conf, verbose)
		self.position_menu = None
		self.set_title(" " + Version + " ")

### Program-applet
class TickerApplet(applet.Applet, MainContainer):
        def __init__(self, V, Version, user_conf, verbose):
                applet.Applet.__init__(self,sys.argv[1])
		self.applet = True
		MainContainer.__init__(self, V, Version, user_conf, verbose)
		self.__Options = None

### if Applet or Window, the messages will be shown in the following
### box. It contain's the icon and the label and holds methods to
### set and reset mesages and icons
class Label_box(g.HBox):
    	def __init__(self, Options):
    		self.Options = Options
		g.HBox.__init__(self,g.FALSE, 0)
    		### set a little border, then there is space in applet for rox-standard-applet menu
		self.set_border_width(1)
		self.image = TickBild(Options)
		self.label = TickLabel(Options)
    		self.pack_start(self.image, g.FALSE, g.FALSE, 3)
    		self.pack_start(self.label, g.FALSE, g.FALSE, 3)
		self.show()
	### three kinds of methods to show status messages
	### those messages will be deleted after some seconds showing
	def status(self, Message):
		if self.Options.check_verbose.int_value: self.label.set_status(Message)
		if self.Options.v: print Message
		self.start_killTask()
	def status_1(self, Message, Stock):
		if self.Options.check_verbose.int_value: self.label.set_status(Message)
		if self.Options.v: print Message
		if self.Options.check_verbose.int_value or self.Options.check_image.int_value: self.image.set_from_stock_tmp(Stock)
		self.start_killTask()
	def status_2(self, Message, File, Stock):
		if self.Options.check_verbose.int_value: self.label.set_status(Message)
		if self.Options.v: print Message
		if self.Options.check_verbose.int_value: self.image.get_from_file_tmp(File)
		if self.Options.check_image.int_value: self.image.set_from_stock_tmp(Stock)
		self.start_killTask()
	def start_killTask(self):
		tasks.Task(self.kill_status_msg())
	def kill_status_msg(self):
		### this is the time for showing status messages
		yield tasks.TimeoutBlocker(3)
		self.label.reset()
		self.image.reset()
	### initiate callback-events, its importend to initiate them after initiating
	### after news and show_list in main class
	def set_callback_events(self, parent, show_list):
		self.label.set_callback_events(show_list)
		self.image.set_callback_events(parent, show_list)

### The folloing class contains the iconimage and is directly derived from EventImage
### as a special Feauture this class contains a second EventBuf, which enables storing
### and displaying of another icon as a (graphical) status-message
class TickBild(tool.EventImage):
	def __init__(self, Options):
    		self.Options = Options
		self.show_list = None  ### This will be set later in set_callback_events
		tool.EventImage.__init__(self, g.STOCK_MISSING_IMAGE, None, None)
		self.get_from_file(rox.app_dir+"/AppIcon.xpm")
		self.tooltip = g.Tooltips(); self.tooltip.enable()
		self.tooltip.set_tip(self, " " + self.Options.Version + " ")
		self.EventBuf_tmp = tool.EventBuffers()  # a second Buffer for Status-Msg_Icons
	### second set of Methods for setting/resetting status Icon
	def get_from_file_tmp(self,Filename):
		self.EventBuf_tmp.get_from_file(self, Filename)
		self.image.set_from_icon_set(self.EventBuf_tmp.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	def set_from_stock_tmp(self, Stock):
		self.EventBuf_tmp.set_from_stock(self, Stock)
		self.image.set_from_icon_set(self.EventBuf_tmp.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	def reset(self):
		self.image.set_from_icon_set(self.EventBuf.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	### adding a tooltip as the user like it :)
	def addTip(self, fd, news):
		def brk_tip(tooltip):
			if tooltip == "": return ""
			else: return "\n"
		tooltip = ""
		if self.Options.tt_i.int_value: 
			self.tooltip.enable()
			if self.Options.tt_i_frame.int_value: tooltip += "---------------------------------------------"
			if self.Options.tt_i_title.int_value: tooltip += brk_tip(tooltip) + "Ticker : " + tool.unxml(fd.title).encode("utf-8")
			if self.Options.tt_i_frame.int_value: tooltip += brk_tip(tooltip) + "---------------------------------------------"
			if self.Options.tt_i_desc.int_value:
				desc = fd.desc
				if len(desc) > 100: desc = desc[:100] + "..."
				tooltip += brk_tip(tooltip) + tool.unxml(desc).encode("utf-8")
			if self.Options.tt_i_frame.int_value: tooltip += brk_tip(tooltip)
			if self.Options.tt_i_src.int_value: tooltip += brk_tip(tooltip) + "Src : " + tool.unxml(fd.ticker).encode("utf-8")
			if self.Options.tt_i_link.int_value: tooltip += brk_tip(tooltip) + "Link : " + tool.unxml(fd.link).encode("utf-8")
			if self.Options.tt_i_ver.int_value:  tooltip += brk_tip(tooltip) + " *** " + self.Options.Version + " *** \n" + news.stat()
			self.tooltip.set_tip(self, tooltip)
		else:
			self.tooltip.disable()
	### callbacks and initiating
	def set_callback_events(self, parent, show_list):
		self.show_list = show_list
		self.con_parent = parent ### change this (position_menu)
		self.connect("button_press_event", self.callback_image)
	def callback_image(self, widget, event):
		if event.button == 1: tasks.Task(self.show_list.open_page_feed())
        	if event.button == 2: self.con_show_list.update_ticker_()
		### change this (position_menu)
		if event.button == 3: self.emit("open_menu", event)
	### some Methods for Menu-Calls, they are landing here
	def quit(self): quit(None)
	def help(self): help()
	def info(self): info()
	def show_options(self): show_options()
	def update_ticker(self): main.show_list.update_ticker()
	def refresh_ticker(self): tasks.Task(main.news.refresh_ticker())
	def show_window(self): tasks.Task(overview.show_window())
	def enter_widget(self, widget, event):
		#print "show now"
		self.emit("tickbild_entered")
		widget.set_state (g.STATE_PRELIGHT)
	def leave_widget(self, widget, event):
		self.emit("tickbild_leaved")
		widget.set_state (g.STATE_NORMAL)

gobject.signal_new("open_menu", TickBild, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))

gobject.signal_new("tickbild_entered", TickBild, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	())

gobject.signal_new("tickbild_leaved", TickBild, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	())

### The next Class is a label with two kinds of messages, news and status messages
### news messages should be shown always, but status messages should only be shown
### for some seconds (see parent box class)
class TickLabel(g.EventBox):
	def __init__(self, Options):
		self.Options = Options
		self.show_list = None ## will be set later in callback-events
		g.EventBox.__init__(self)
		#### create the main label
		self.text = " " + self.Options.Version + " " # There the real Message is stored while showing status Message
		self.label = g.Label(self.text)
		self.label.show()
		self.add(self.label)
		self.tooltip = g.Tooltips(); self.tooltip.enable()
		self.tooltip.set_tip(self, " " + self.Options.Version + " ")
		self.set_events(g.gdk.ENTER_NOTIFY_MASK | g.gdk.LEAVE_NOTIFY_MASK)
		self.set_color(None)
		self.show()
	def set_status(self, Label): #show status-messages only if wished
		self.label.set_text(Label)
	def reset(self):
		self.label.set_text(self.text)
	def update(self,Label):
		self.text = Label
		self.label.set_text(self.text)
	def set_color(self, dummy):
		self.label.modify_fg(g.STATE_NORMAL, g.gdk.color_parse(self.Options.text_color.value))
		self.label.modify_fg(g.STATE_PRELIGHT, tool.text_color_prelight(self.Options))
	def addTip(self, i):
		def brk_tip(tooltip):
			if tooltip == "": return ""
			else: return "\n"
		tooltip = ""
		if self.Options.tt_l.int_value: 
			self.tooltip.enable()
			if self.Options.tt_l_frame.int_value: tooltip += "---------------------------------------------"
			if self.Options.tt_l_title.int_value: tooltip += brk_tip(tooltip) + tool.unxml(i.title).encode("utf-8")
			if self.Options.tt_l_frame.int_value: tooltip += brk_tip(tooltip) + "---------------------------------------------"
			tooltip += brk_tip(tooltip) + tool.unxml(i.desc).encode("utf-8")
			if self.Options.tt_l_frame.int_value: tooltip += brk_tip(tooltip)
			if self.Options.tt_l_link.int_value: tooltip += brk_tip(tooltip) + "Link   : " + tool.unxml(i.link).encode("utf-8")
			if self.Options.tt_l_ver.int_value:  tooltip += brk_tip(tooltip) + " *** " + self.Options.Version + " *** "
			self.tooltip.set_tip(self, tooltip)
		else:
			self.tooltip.disable()
	def set_callback_events(self, show_list):
		self.show_list = show_list
		self.connect("enter-notify-event", self.enter_widget)
		self.connect("leave-notify-event", self.leave_widget)
		self.connect("button_press_event", self.callback_label)
	def enter_widget(self, widget, event):
		self.show_list.rem_update()
		widget.set_state (g.STATE_PRELIGHT)
	def leave_widget(self, widget, event):
		self.show_list.add_update()
		widget.set_state (g.STATE_NORMAL)
	def callback_label(self, widget, event):
		if event.button == 1: tasks.Task(self.show_list.open_page())
        	if event.button == 2: self.show_list.update_ticker_()
		if event.button == 3: self.show_list.update_ticker_()

